Index: trunk/src/VBox/Devices/Makefile.kmk
===================================================================
--- trunk/src/VBox/Devices/Makefile.kmk	(revision 37747)
+++ trunk/src/VBox/Devices/Makefile.kmk	(revision 37752)
@@ -58,6 +58,6 @@
   VBoxDDU_DEFS           += VBOX_WITH_USB IN_USBLIB
   VBoxDDU_SDKS.win        = WINPSDK W2K3DDK
-  if defined(VBOX_WITH_EHCI) && !defined(VBOX_WITH_EXTPACK_PUEL)
-   VBoxDDU_DEFS          += VBOX_WITH_EHCI
+  if defined(VBOX_WITH_EHCI_IMPL) && !defined(VBOX_WITH_EXTPACK_PUEL)
+   VBoxDDU_DEFS          += VBOX_WITH_EHCI_IMPL
   endif
   ifdef VBOX_WITH_NEW_USB_CODE_ON_DARWIN
@@ -123,6 +123,6 @@
  ifdef VBOX_WITH_USB
   VBoxDD_DEFS           += VBOX_WITH_USB
-  if defined(VBOX_WITH_EHCI) && !defined(VBOX_WITH_EXTPACK_PUEL)
-   VBoxDD_DEFS          += VBOX_WITH_EHCI
+  if defined(VBOX_WITH_EHCI_IMPL) && !defined(VBOX_WITH_EXTPACK_PUEL)
+   VBoxDD_DEFS          += VBOX_WITH_EHCI_IMPL
   endif
  endif
@@ -449,6 +449,6 @@
  ifdef VBOX_WITH_USB
   DevicesR3_DEFS        += VBOX_WITH_USB
-  if defined(VBOX_WITH_EHCI) && !defined(VBOX_WITH_EXTPACK_PUEL)
-   DevicesR3_DEFS       += VBOX_WITH_EHCI
+  if defined(VBOX_WITH_EHCI_IMPL) && !defined(VBOX_WITH_EXTPACK_PUEL)
+   DevicesR3_DEFS       += VBOX_WITH_EHCI_IMPL
    DevicesR3_SOURCES    += \
  	USB/DevEHCI.cpp
@@ -604,6 +604,6 @@
   ifdef VBOX_WITH_USB
    VBoxDDGC_DEFS        += VBOX_WITH_USB
-   if defined(VBOX_WITH_EHCI) && !defined(VBOX_WITH_EXTPACK_PUEL)
-    VBoxDDGC_DEFS       += VBOX_WITH_EHCI
+   if defined(VBOX_WITH_EHCI_IMPL) && !defined(VBOX_WITH_EXTPACK_PUEL)
+    VBoxDDGC_DEFS       += VBOX_WITH_EHCI_IMPL
     VBoxDDGC_SOURCES    += \
   	USB/DevEHCI.cpp
@@ -709,6 +709,6 @@
  ifdef VBOX_WITH_USB
  VBoxDDR0_DEFS          += VBOX_WITH_USB
-  if defined(VBOX_WITH_EHCI) && !defined(VBOX_WITH_EXTPACK_PUEL)
-   VBoxDDR0_DEFS        += VBOX_WITH_EHCI
+  if defined(VBOX_WITH_EHCI_IMPL) && !defined(VBOX_WITH_EXTPACK_PUEL)
+   VBoxDDR0_DEFS        += VBOX_WITH_EHCI_IMPL
    VBoxDDR0_SOURCES     += \
  	USB/DevEHCI.cpp
Index: trunk/src/VBox/Devices/build/VBoxDD.cpp
===================================================================
--- trunk/src/VBox/Devices/build/VBoxDD.cpp	(revision 37747)
+++ trunk/src/VBox/Devices/build/VBoxDD.cpp	(revision 37752)
@@ -133,5 +133,5 @@
         return rc;
 #endif
-#ifdef VBOX_WITH_EHCI
+#ifdef VBOX_WITH_EHCI_IMPL
     rc = pCallbacks->pfnRegister(pCallbacks, &g_DeviceEHCI);
     if (RT_FAILURE(rc))
Index: trunk/src/VBox/Devices/testcase/Makefile.kmk
===================================================================
--- trunk/src/VBox/Devices/testcase/Makefile.kmk	(revision 37747)
+++ trunk/src/VBox/Devices/testcase/Makefile.kmk	(revision 37752)
@@ -29,5 +29,5 @@
 	$(if $(VBOX_WITH_RAW_MODE),VBOX_WITH_RAW_MODE,) \
 	$(if $(VBOX_WITH_USB),VBOX_WITH_USB,) \
-	$(if $(VBOX_WITH_EHCI),VBOX_WITH_EHCI,) \
+	$(if $(VBOX_WITH_EHCI_IMPL),VBOX_WITH_EHCI_IMPL,) \
 	$(if $(VBOX_WITH_AHCI),VBOX_WITH_AHCI,) \
 	$(if $(VBOX_WITH_E1000),VBOX_WITH_E1000,) \
Index: trunk/src/VBox/Devices/testcase/tstDeviceStructSize.cpp
===================================================================
--- trunk/src/VBox/Devices/testcase/tstDeviceStructSize.cpp	(revision 37747)
+++ trunk/src/VBox/Devices/testcase/tstDeviceStructSize.cpp	(revision 37752)
@@ -68,5 +68,5 @@
 # undef LOG_GROUP
 # include "../USB/DevOHCI.cpp"
-# ifdef VBOX_WITH_EHCI
+# ifdef VBOX_WITH_EHCI_IMPL
 #  include "../USB/DevEHCI.cpp"
 # endif
@@ -285,5 +285,5 @@
     //CHECK_MEMBER_ALIGNMENT(E1KSTATE, csTx, 8);
 #ifdef VBOX_WITH_USB
-# ifdef VBOX_WITH_EHCI
+# ifdef VBOX_WITH_EHCI_IMPL
     CHECK_MEMBER_ALIGNMENT(EHCI, RootHub, 8);
 #  ifdef VBOX_WITH_STATISTICS
Index: trunk/src/VBox/Devices/testcase/tstDeviceStructSizeRC.cpp
===================================================================
--- trunk/src/VBox/Devices/testcase/tstDeviceStructSizeRC.cpp	(revision 37747)
+++ trunk/src/VBox/Devices/testcase/tstDeviceStructSizeRC.cpp	(revision 37752)
@@ -63,5 +63,5 @@
 # undef LOG_GROUP
 # include "../USB/DevOHCI.cpp"
-# ifdef VBOX_WITH_EHCI
+# ifdef VBOX_WITH_EHCI_IMPL
 #  include "../USB/DevEHCI.cpp"
 # endif
@@ -929,5 +929,5 @@
     GEN_CHECK_OFF(OHCI, StatTimer);
 # endif
-# ifdef VBOX_WITH_EHCI
+# ifdef VBOX_WITH_EHCI_IMPL
     /* USB/DevEHCI.cpp */
     GEN_CHECK_SIZE(EHCIHUBPORT);
@@ -1006,5 +1006,5 @@
     GEN_CHECK_OFF(EHCI, pEOFTimerNoSyncR3);
     GEN_CHECK_OFF(EHCI, pEOFTimerNoSyncR0);
-# endif /* VBOX_WITH_EHCI */
+# endif /* VBOX_WITH_EHCI_IMPL */
 #endif /* VBOX_WITH_USB */
 