Index: /trunk/src/VBox/Devices/Network/slirp/ip_icmp.c
===================================================================
--- /trunk/src/VBox/Devices/Network/slirp/ip_icmp.c	(revision 37935)
+++ /trunk/src/VBox/Devices/Network/slirp/ip_icmp.c	(revision 37936)
@@ -186,5 +186,5 @@
 
 
-    Log(("%s: processing (proto:%d)\n", __FUNCTION__, ip->ip_p));
+    LogFlowFunc(("ENTER: ip->ip_p:%d\n", ip->ip_p));
     switch (ip->ip_p)
     {
@@ -295,9 +295,14 @@
          */
         LIST_INSERT_HEAD(&pData->icmp_msg_head, icm, im_list);
+        LogFlowFunc(("LEAVE: icm:%p\n", icm));
         return (icm);
     }
     if (found == 1)
+    {
+        LogFlowFunc(("LEAVE: icm:%p\n", icm));
         return icm;
-
+    }
+
+    LogFlowFunc(("LEAVE: NULL\n"));
     return NULL;
 }
@@ -335,5 +340,5 @@
     /* int code; */
 
-    LogFlow(("icmp_input: m = %lx, m_len = %d\n", (long)m, m ? m->m_len : 0));
+    LogFlowFunc(("ENTER: m = %lx, m_len = %d\n", (long)m, m ? m->m_len : 0));
 
     icmpstat.icps_received++;
@@ -677,4 +682,5 @@
     /* clear source datagramm in positive branch */
     m_freem(pData, msrc);
+    LogFlowFuncLeave();
     return;
 
@@ -698,4 +704,5 @@
         }
     }
+    LogFlowFuncLeave();
 }
 #undef ICMP_MAXDATALEN
@@ -712,4 +719,5 @@
     int optlen = hlen - sizeof(struct ip);
     register struct icmp *icp;
+    LogFlowFunc(("ENTER: m:%p\n", m));
 
     /*
@@ -730,3 +738,4 @@
 
     icmpstat.icps_reflect++;
+    LogFlowFuncLeave();
 }
Index: /trunk/src/VBox/Devices/Network/slirp/ip_input.c
===================================================================
--- /trunk/src/VBox/Devices/Network/slirp/ip_input.c	(revision 37935)
+++ /trunk/src/VBox/Devices/Network/slirp/ip_input.c	(revision 37936)
@@ -111,5 +111,5 @@
     STAM_PROFILE_START(&pData->StatIP_input, a);
 
-    LogFlow(("ip_input: m = %lx\n", (long)m));
+    LogFlowFunc(("ENTER: m = %lx\n", (long)m));
     ip = mtod(m, struct ip *);
     Log2(("ip_dst=%RTnaipv4(len:%d) m_len = %d\n", ip->ip_dst, RT_N2H_U16(ip->ip_len), m->m_len));
@@ -243,4 +243,5 @@
 no_free_m:
     STAM_PROFILE_STOP(&pData->StatIP_input, a);
+    LogFlowFuncLeave();
     return;
 }
@@ -257,4 +258,5 @@
 
     /* If maxnipq or maxfragsperpacket are 0, never accept fragments. */
+    LogFlowFunc(("ENTER: m:%p\n", m));
     if (   maxnipq == 0
         || maxfragsperpacket == 0)
@@ -263,4 +265,5 @@
         ipstat.ips_fragdropped++;
         m_freem(pData, m);
+        LogFlowFunc(("LEAVE: NULL\n"));
         return (NULL);
     }
@@ -530,4 +533,5 @@
 #endif
     ipstat.ips_reassembled++;
+    LogFlowFunc(("LEAVE: %p\n", m));
     return (m);
 
@@ -539,4 +543,5 @@
 
 done:
+    LogFlowFunc(("LEAVE: NULL\n"));
     return NULL;
 
Index: /trunk/src/VBox/Devices/Network/slirp/ip_output.c
===================================================================
--- /trunk/src/VBox/Devices/Network/slirp/ip_output.c	(revision 37935)
+++ /trunk/src/VBox/Devices/Network/slirp/ip_output.c	(revision 37936)
@@ -73,7 +73,9 @@
 {
     int rc;
+    LogFlowFunc(("ENTER: dst:%RTnaipv4, ether:%p\n", dst, ether));
     if (dst == INADDR_BROADCAST)
     {
         memcpy(ether, broadcast_ethaddr, ETH_ALEN);
+        LogFlowFunc(("LEAVE: VINF_SUCCESS\n"));
         return VINF_SUCCESS;
     }
@@ -81,13 +83,20 @@
     rc = slirp_arp_lookup_ether_by_ip(pData, dst, ether);
     if (RT_SUCCESS(rc))
+    {
+        LogFlowFunc(("LEAVE: %Rrc\n", rc));
         return rc;
+    }
 
     rc = bootp_cache_lookup_ether_by_ip(pData, dst, ether);
     if (RT_SUCCESS(rc))
+    {
+        LogFlowFunc(("LEAVE: %Rrc\n", rc));
         return rc;
+    }
     /*
      * no chance to send this packet, sorry, we will request ether address via ARP
      */
     slirp_arp_who_has(pData, dst);
+    LogFlowFunc(("LEAVE: VERR_NOT_FOUND\n"));
     return VERR_NOT_FOUND;
 }
@@ -120,5 +129,5 @@
     STAM_PROFILE_START(&pData->StatIP_output, a);
 
-    LogFlow(("ip_output: so = %lx, m0 = %lx\n", (long)so, (long)m0));
+    LogFlowFunc(("ip_output: so = %R[natsock], m0 = %lx\n", so, (long)m0));
 
     M_ASSERTPKTHDR(m);
@@ -329,4 +338,5 @@
 done:
     STAM_PROFILE_STOP(&pData->StatIP_output, a);
+    LogFlowFunc(("LEAVE: %d\n", error));
     return error;
 
@@ -334,4 +344,5 @@
     m_freem(pData, m0);
     STAM_PROFILE_STOP(&pData->StatIP_output, a);
+    LogFlowFunc(("LEAVE: %d\n", error));
     return error;
 }
Index: /trunk/src/VBox/Devices/Network/slirp/sbuf.c
===================================================================
--- /trunk/src/VBox/Devices/Network/slirp/sbuf.c	(revision 37935)
+++ /trunk/src/VBox/Devices/Network/slirp/sbuf.c	(revision 37936)
@@ -284,5 +284,5 @@
 
     STAM_PROFILE_START(&pData->StatIOSBAppend_pf, a);
-    LogFlow(("sbappend: so = %lx, m = %lx, m->m_len = %d\n", (long)so, (long)m, m ? m->m_len : 0));
+    LogFlow(("sbappend: so = %R[natsock], m = %lx, m->m_len = %d\n", so, (long)m, m ? m->m_len : 0));
 
     STAM_COUNTER_INC(&pData->StatIOSBAppend);
Index: /trunk/src/VBox/Devices/Network/slirp/socket.c
===================================================================
--- /trunk/src/VBox/Devices/Network/slirp/socket.c	(revision 37935)
+++ /trunk/src/VBox/Devices/Network/slirp/socket.c	(revision 37936)
@@ -335,5 +335,5 @@
     QSOCKET_UNLOCK(tcb);
 
-    LogFlow(("soread: so = %lx\n", (long)so));
+    LogFlowFunc(("soread: so = %lx\n", (long)so));
 
     if (len > mss)
@@ -410,5 +410,5 @@
     ssize_t ret;
 
-    LogFlow(("sorecvoob: so = %lx\n", (long)so));
+    LogFlowFunc(("sorecvoob: so = %R[natsock]\n", so));
 
     /*
@@ -439,5 +439,5 @@
     int n, len;
 
-    LogFlow(("sosendoob so = %lx\n", (long)so));
+    LogFlowFunc(("sosendoob so = %R[natsock]\n", so));
 
     if (so->so_urgc > sizeof(buff))
@@ -652,5 +652,5 @@
     int n, len;
 
-    LogFlow(("sosendoob: so = %lx\n", (long)so));
+    LogFlowFunc(("sosendoob: so = %R[natsock]\n", so));
 
     len = sbuf_len(sb);
@@ -707,5 +707,5 @@
     socklen_t addrlen = sizeof(struct sockaddr_in);
 
-    LogFlow(("sorecvfrom: so = %lx\n", (long)so));
+    LogFlowFunc(("sorecvfrom: so = %lx\n", (long)so));
 
     if (so->so_type == IPPROTO_ICMP)
@@ -883,5 +883,5 @@
     int mlen;
 
-    LogFlow(("sosendto: so = %lx, m = %lx\n", (long)so, (long)m));
+    LogFlowFunc(("sosendto: so = %R[natsock], m = %lx\n", so, (long)m));
 
     memset(&addr, 0, sizeof(struct sockaddr));
@@ -977,5 +977,5 @@
     int status;
 
-    LogFlow(("solisten: port = %d, laddr = %x, lport = %d, flags = %x\n", port, laddr, lport, flags));
+    LogFlowFunc(("solisten: port = %d, laddr = %x, lport = %d, flags = %x\n", port, laddr, lport, flags));
 
     if ((so = socreate()) == NULL)
Index: /trunk/src/VBox/Devices/Network/slirp/tcp_input.c
===================================================================
--- /trunk/src/VBox/Devices/Network/slirp/tcp_input.c	(revision 37935)
+++ /trunk/src/VBox/Devices/Network/slirp/tcp_input.c	(revision 37936)
@@ -99,6 +99,5 @@
     int flags;
     STAM_PROFILE_START(&pData->StatTCP_reassamble, tcp_reassamble);
-    LogFlowFuncEnter();
-    LogFlowFunc(("pData:%p, tp:%p, th:%p, tlenp:%p, m:%p\n", pData, tp, th, tlenp, m));
+    LogFlowFunc(("ENTER: pData:%p, tp:%R[tcpcb793], th:%p, tlenp:%p, m:%p\n", pData, tp, th, tlenp, m));
 
     /*
@@ -1768,5 +1767,5 @@
     int opt, optlen;
 
-    LogFlow(("tcp_dooptions: tp = %lx, cnt=%i\n", (long)tp, cnt));
+    LogFlowFunc(("tcp_dooptions: tp = %R[tcpcb793], cnt=%i\n", tp, cnt));
 
     for (; cnt > 0; cnt -= optlen, cp += optlen)
@@ -1879,5 +1878,5 @@
     register short delta;
 
-    LogFlow(("tcp_xmit_timer: tp = %lx rtt = %d\n", (long)tp, rtt));
+    LogFlowFunc(("ENTER: tcp_xmit_timer: tp = %R[tcpcb793] rtt = %d\n", tp, rtt));
 
     tcpstat.tcps_rttupdated++;
@@ -1969,5 +1968,5 @@
     int mss;
 
-    LogFlow(("tcp_mss: tp = %lx, offet = %d\n", (long)tp, offer));
+    LogFlowFunc(("ENTER: tcp_mss: tp = %R[tcpcb793], offer = %d\n", tp, offer));
 
     mss = min(if_mtu, if_mru) - sizeof(struct tcpiphdr);
Index: /trunk/src/VBox/Devices/Network/slirp/tcp_output.c
===================================================================
--- /trunk/src/VBox/Devices/Network/slirp/tcp_output.c	(revision 37935)
+++ /trunk/src/VBox/Devices/Network/slirp/tcp_output.c	(revision 37936)
@@ -102,5 +102,5 @@
     int size = 0;
 
-    LogFlow(("tcp_output: tp = %lx\n", (long)tp));
+    LogFlow(("ENTER: tcp_output: tp = %R[tcpcb793]\n", tp));
 
     /*
Index: /trunk/src/VBox/Devices/Network/slirp/tcp_subr.c
===================================================================
--- /trunk/src/VBox/Devices/Network/slirp/tcp_subr.c	(revision 37935)
+++ /trunk/src/VBox/Devices/Network/slirp/tcp_subr.c	(revision 37936)
@@ -129,6 +129,6 @@
     int win = 0;
 
-    LogFlow(("tcp_respond: tp = %lx, ti = %lx, m = %lx, ack = %u, seq = %u, flags = %x\n",
-              (long)tp, (long)ti, (long)m, ack, seq, flags));
+    LogFlowFunc(("ENTER: tp = %R[tcpcb793], ti = %lx, m = %lx, ack = %u, seq = %u, flags = %x\n",
+                 tp, (long)ti, (long)m, ack, seq, flags));
 
     if (tp)
@@ -244,5 +244,5 @@
 {
 */
-    LogFlow(("tcp_drop: tp = %lx, errno = %d\n", (long)tp, errno));
+    LogFlowFunc(("ENTER: tp = %R[tcpcb793], errno = %d\n", tp, errno));
 
     if (TCPS_HAVERCVDSYN(tp->t_state))
@@ -276,5 +276,5 @@
 
     struct tseg_qent *te = NULL;
-    LogFlow(("tcp_close: tp = %lx\n", (long)tp));
+    LogFlowFunc(("ENTER: tp = %R[tcpcb793]\n", tp));
     so_next = so_prev = NULL;
     /*XXX: freeing the reassembly queue */
@@ -353,5 +353,5 @@
 tcp_sockclosed(PNATState pData, struct tcpcb *tp)
 {
-    LogFlow(("tcp_sockclosed: tp = %lx\n", (long)tp));
+    LogFlowFunc(("ENTER: tp = %R[tcpcb793]\n", tp));
 
     switch (tp->t_state)
@@ -403,5 +403,5 @@
     int ret = 0;
 
-    LogFlow(("tcp_fconnect: so = %lx\n", (long)so));
+    LogFlowFunc(("ENTER: so = %R[natsock]\n", so));
 
     if ((ret = so->s = socket(AF_INET, SOCK_STREAM, 0)) >= 0)
@@ -472,5 +472,5 @@
     static int cVerbose = 1;
 
-    LogFlow(("tcp_connect: inso = %lx\n", (long)inso));
+    LogFlowFunc(("ENTER: inso = %R[natsock]\n", inso));
 
     /*
Index: /trunk/src/VBox/Devices/Network/slirp/tcp_timer.c
===================================================================
--- /trunk/src/VBox/Devices/Network/slirp/tcp_timer.c	(revision 37935)
+++ /trunk/src/VBox/Devices/Network/slirp/tcp_timer.c	(revision 37936)
@@ -66,5 +66,5 @@
     register struct tcpcb *tp;
 
-    LogFlow(("tcp_fasttimo:\n"));
+    LogFlowFuncEnter();
 
     so = tcb.so_next;
@@ -96,5 +96,5 @@
     register int i;
 
-    LogFlow(("tcp_slowtimo:\n"));
+    LogFlowFuncEnter();
 
     /*
@@ -159,5 +159,5 @@
     register int rexmt;
 
-    LogFlow(("tcp_timers:\n"));
+    LogFlowFunc(("ENTER: tp:%R[tcpcb793], timer:%d\n", tp, timer));
 
     switch (timer)
Index: /trunk/src/VBox/Devices/Network/slirp/udp.c
===================================================================
--- /trunk/src/VBox/Devices/Network/slirp/udp.c	(revision 37935)
+++ /trunk/src/VBox/Devices/Network/slirp/udp.c	(revision 37936)
@@ -95,5 +95,5 @@
     int ttl;
 
-    LogFlow(("udp_input: m = %lx, iphlen = %d\n", (long)m, iphlen));
+    LogFlowFunc(("ENTER: m = %p, iphlen = %d\n", m, iphlen));
     ip = mtod(m, struct ip *);
     Log2(("%RTnaipv4 iphlen = %d\n", ip->ip_dst, iphlen));
@@ -194,4 +194,5 @@
         m->m_len -= sizeof(struct udpiphdr);
         udp_output2(pData, NULL, m, &src, &dst, IPTOS_LOWDELAY);
+        LogFlowFuncLeave();
         return;
     }
@@ -300,4 +301,5 @@
         icmp_error(pData, m, ICMP_UNREACH, ICMP_UNREACH_NET, 0, strerror(errno));
         so->so_m = NULL;
+        LogFlowFuncLeave();
         return;
     }
@@ -311,4 +313,5 @@
     *ip = save_ip;
     so->so_m = m;         /* ICMP backup */
+    LogFlowFuncLeave();
     return;
 
@@ -323,4 +326,5 @@
      */
     m_freem(pData, m);
+    LogFlowFuncLeave();
     return;
 }
@@ -339,6 +343,6 @@
     int mlen = 0;
 
-    LogFlow(("udp_output: so = %lx, m = %lx, saddr = %lx, daddr = %lx\n",
-            (long)so, (long)m, (long)saddr->sin_addr.s_addr, (long)daddr->sin_addr.s_addr));
+    LogFlowFunc(("ENTER: so = %R[natsock], m = %lx, saddr = %lx, daddr = %lx\n",
+                 so, (long)m, (long)saddr->sin_addr.s_addr, (long)daddr->sin_addr.s_addr));
 
     /*