Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_de.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_de.ts	(revision 37942)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_de.ts	(revision 37943)
@@ -338,5 +338,5 @@
     <message>
         <source>Dock Icon</source>
-        <translation></translation>
+        <translation>Dock-Icon</translation>
     </message>
     <message>
@@ -2031,5 +2031,5 @@
     <message>
         <source>no host-only network adapter is selected</source>
-        <translation></translation>
+        <translation>haben Sie keinen Host-Only-Netzwerkadapter ausgewählt</translation>
     </message>
     <message>
@@ -2112,5 +2112,5 @@
     <message>
         <source>Generic Properties:</source>
-        <translation>Generische Eigenschaften:</translation>
+        <translation>Konfiguration:</translation>
     </message>
     <message>
@@ -2550,5 +2550,5 @@
     <message>
         <source>Information</source>
-        <translation>Information</translation>
+        <translation>Informationen</translation>
     </message>
     <message>
@@ -2590,9 +2590,9 @@
     <message>
         <source>Virtual Size:</source>
-        <translation>Virtuelle Größe:</translation>
+        <translation>virtuelle Größe:</translation>
     </message>
     <message>
         <source>Actual Size:</source>
-        <translation>Wirkliche Größe:</translation>
+        <translation>tatsächliche Größe:</translation>
     </message>
     <message>
@@ -2602,5 +2602,5 @@
     <message>
         <source>Location:</source>
-        <translation>Ort:</translation>
+        <translation>abgespeichert als:</translation>
     </message>
     <message>
@@ -2610,5 +2610,5 @@
     <message>
         <source>Attached To:</source>
-        <translation>Angeschlossen an:</translation>
+        <translation>angeschlossen an:</translation>
     </message>
     <message>
@@ -2721,5 +2721,5 @@
     </message>
     <message>
-        <source>Details:</source>
+        <source>wie abgespeichert:</source>
         <translation></translation>
     </message>
@@ -3183,5 +3183,5 @@
     <message>
         <source>&lt;p&gt;You are about to change the attributes of the virtual disk located in &lt;b&gt;%1&lt;/b&gt;.&lt;/p&gt;&lt;p&gt;Please choose one of the following medium types and press &lt;b&gt;%2&lt;/b&gt; to proceed or &lt;b&gt;%3&lt;/b&gt; otherwise.&lt;/p&gt;</source>
-        <translation>&lt;p&gt;Sie möchten die Attribute der virtuellen Platte in &lt;b&gt;%1&lt;/b&gt; ändern.&lt;/p&gt;&lt;p&gt;Bitte benutzen Sie einen der folgenden Medientypen und wählen dann &lt;b&gt;%2&lt;/b&gt; um fortzufahren oder &lt;b&gt;%3&lt;/b&gt;.&lt;/p&gt;</translation>
+        <translation>&lt;p&gt;Sie möchten die Attribute der virtuellen Festplatte &lt;b&gt;%1&lt;/b&gt; ändern.&lt;/p&gt;&lt;p&gt;Bitte wählen Sie einen der folgenden Medientypen und bestätigen dann mit &lt;b&gt;%2&lt;/b&gt; um fortzufahren oder verwerfen die Änderung mit &lt;b&gt;%3&lt;/b&gt;.&lt;/p&gt;</translation>
     </message>
     <message>
@@ -3352,5 +3352,5 @@
     </message>
     <message>
-        <source>Details</source>
+        <source>wie abgespeichert</source>
         <comment>summary</comment>
         <translation></translation>
@@ -5173,15 +5173,15 @@
         <source>Deny</source>
         <comment>NetworkAdapterPromiscModePolicyType</comment>
-        <translation type="unfinished"></translation>
+        <translation>verweigern (deny)</translation>
     </message>
     <message>
         <source>Allow VMs</source>
         <comment>NetworkAdapterPromiscModePolicyType</comment>
-        <translation>VMs erlauben</translation>
+        <translation>erlauben für alle VMs</translation>
     </message>
     <message>
         <source>Allow All</source>
         <comment>NetworkAdapterPromiscModePolicyType</comment>
-        <translation>Allen erlauben</translation>
+        <translation>erlauben für allen VMs und den Host</translation>
     </message>
     <message>
@@ -5256,5 +5256,5 @@
     <message>
         <source>VirtualBox License</source>
-        <translation></translation>
+        <translation>VirtualBox-Lizenz</translation>
     </message>
     <message>
@@ -5357,5 +5357,5 @@
     <message>
         <source>Release the selected medium by detaching it from the machines</source>
-        <translation>Hebt die Verbindung des ausgewählten Medium an alle virtuellen Maschinen auf</translation>
+        <translation>Löst die Bindung des ausgewählten Medium an alle virtuellen Maschinen</translation>
     </message>
     <message>
@@ -5458,5 +5458,5 @@
     <message>
         <source>Storage details:</source>
-        <translation type="unfinished"></translation>
+        <translation>Art der Abspeicherung:</translation>
     </message>
     <message>
@@ -5470,5 +5470,5 @@
     <message>
         <source>Copy an existing medium</source>
-        <translation>Kopiert ein Medium</translation>
+        <translation>Erstellt eine Kopie des Medium</translation>
     </message>
     <message>
@@ -6441,5 +6441,5 @@
     <message>
         <source>&lt;p&gt;You are about to restore snapshot &lt;b&gt;%1&lt;/b&gt;.&lt;/p&gt;&lt;p&gt;You can create a snapshot of the current state of the virtual machine first by checking the box below; if you do not do this the current state will be permanently lost. Do you wish to proceed?&lt;/p&gt;</source>
-        <translation type="unfinished"></translation>
+        <translation>&lt;p&gt;Sie möchten zum Sicherungspunkt &lt;b&gt;%1&lt;/b&gt; zurückkehren.&lt;/p&gt;&lt;p&gt;Sie können gleichzeitig durch Auswahl der Checkbox einen Sicherungspunkt für den aktuellen Zustand anlegen, anderenfalls geht der aktuelle Zustand unwiderruflich verloren. Möchten Sie fortfahren?&lt;/p&gt;</translation>
     </message>
     <message>
@@ -6453,5 +6453,5 @@
     <message>
         <source>&lt;p&gt;Cannot create the machine folder &lt;b&gt;%1&lt;/b&gt; in the parent folder &lt;nobr&gt;&lt;b&gt;%2&lt;/b&gt;.&lt;/nobr&gt;&lt;/p&gt;&lt;p&gt;Please check that the parent really exists and that you have permissions to create the machine folder.&lt;/p&gt;</source>
-        <translation type="unfinished"></translation>
+        <translation>&lt;p&gt;Das Maschinen-Verzeichnis &lt;b&gt;%1&lt;/b&gt; konnte nicht im Verzeichnis &lt;nobr&gt;&lt;b&gt;%2&lt;/b&gt;&lt;/nobr&gt; erzeugt werden.&lt;/p&gt;&lt;p&gt;Bitte überprüfen Sie, ob das übergeordnete Verzeichnis vorhanden ist und ob Sie geeignete Zugriffsrechte zum Erzeugen des Maschinen-Verzeichnisses haben.&lt;/p&gt;</translation>
     </message>
     <message>
@@ -6505,5 +6505,5 @@
     <message>
         <source>The state of the virtual machine you currently edit has changed. Only settings which are editable at runtime are saved when you press OK. All changes to other settings will be lost.</source>
-        <translation type="unfinished"></translation>
+        <translation>Der Zustand der virtuellen Maschine hat sich in der Zwischenzeit geändert. Durch Bestätigen werden nur die zur Laufzeit änderbaren Einstellungen abgespeichert. Alle anderen Änderungen gehen verloren.</translation>
     </message>
     <message>
@@ -6744,5 +6744,5 @@
     <message>
         <source>D&amp;iscard Saved State</source>
-        <translation type="unfinished"></translation>
+        <translation>&amp;Verwerfen</translation>
     </message>
     <message>